/**
 * @file yexception.h
 * @brief 㳰
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-01-30
 *
 * Copyright (C) 2003-2004, Yashiro Takeshi
 */

#ifndef DEFINE_H_YEXCEPTION
#define DEFINE_H_YEXCEPTION

#include <basic.h>
#include <ystring.h>

/** 㳰
 *
 * 㳰򰷤δȤʤ륯饹Ǥ
 */
class YException {
protected:
  /// 顼å
  YString msg;

  /// 顼ֹ
  WERR id;
  
public:
  /** 󥹥ȥ饯
   *
   * 顼ֹꤷƽޤ
   * @param 
   */
  YException(W n = 0) {
    id = n;
  }
  
  /** 󥹥ȥ饯
   *
   * 顼åꤷƽޤ
   * @param str 顼å
   * @param n 顼ֹ
   */
  YException(const TC* str, W n = 0) {
    msg = str;
    id = n;
  }

  /** 󥹥ȥ饯
   *
   * 顼åꤷƽޤ
   * @param str 顼å
   * @param n 顼ֹ
   */
  YException(const YString& str, W n = 0) {
    msg = str;
    id = n;
  }

  /// ǥȥ饯
  virtual ~YException() {}  

  /** 顼åμ
   *
   * 顼åޤ
   * @return 顼å
   */
  virtual YString getMessage() {
    return msg;
  }

  virtual int getErrorID() {
    return id;
  }
  // dispErrorOnPanel(); (?)

};

#endif // DEFINE_H_YEXCEPTION
